%% "   "
%    No2
% :        
%          - ABC, 120, 0, dq0
clear, clc, format compact, format short

%%  1 -  
%         gr
gr = pi/180;
j  = sqrt(-1);
q3 = sqrt(3);
a  = 1*exp(j*(+120*gr));
a2 = a*a;

%  
% S    ABC  120
S=(1/3)*[1  a  a2;
         1  a2 a ;
         1  1  1 ];

% K    ABC  0
K=(1/3)*[2 -1  -1;
         0 -q3 q3;
         1  1  1 ];

%%  1.   ABC  120  0   
%    Sp   
fprintf('\n### 1 / . 1\n');
correctInput = false;
while not(correctInput)
    KU = input('#  KU = ');
    if not(isempty(KU)) && isreal(KU)
        correctInput = true;
    else
        fprintf(' KU     !\n ');
    end
end
fprintf('# KI = %5.2f\n', KU);

%          
%              - ABC
Ubase = [ 6.2*exp(j*(0*gr));
          5.7*exp(j*(-115*gr));
          6.1*exp(j*(+150*gr))];
Ibase = [ 1.2*exp(j*(-40*gr));
          1.0*exp(j*(-140*gr));
          1.05*exp(j*(+112*gr))];

fprintf('\n#  :\n');
U = Ubase * KU
I = Ibase * KU

%            - 120
Us=S*U;
Is=S*I;

%           - 0
Uk=K*U;
Ik=K*I;

%       
% )     - ABC
Spf=U.'*conj(I);

% )     - 120
Sps=3*Us.'*conj(Is);

% )    - 0
Spk=3/2*( Uk(1,1)*conj(Ik(1,1)) +Uk(2,1)*conj(Ik(2,1)) ) +3*Uk(3,1)*conj(Ik(3,1));

% 
fprintf('\n#  1 ):\n');
U
Us
Uk
fprintf('\n');
I
Is
Ik
fprintf('\n(       )\n');
pause;
fprintf(['\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\n\n']);

fprintf('\n#  1 ):\n');
Spf
Sps
Spk
fprintf('\n(       )\n');
pause;
fprintf(['\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\n\n']);

%%  2.   120  ABC   
fprintf('\n\n### 1 / . 2\n');
fprintf('# KS = %5.2f\n', KU);

%          - 120
Us_base =[ 66.2*exp(j*(0*gr));
         12.0*exp(j*(+170*gr));
         18.0*exp(j*(+175*gr))];

fprintf('\n#  :\n');
Us = Us_base * KU

%          - ABC
U = inv(S)*Us;

% 
fprintf('\n# :\n');
Us
fprintf('\n');
U
fprintf('\n(       )\n');
pause;
fprintf(['\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\n\n']);

%%    3.   ABC  120   
fprintf('\n\n### 1 / . 3 )\n');
%   a.   
% Zaa=Zbb=Zcc=z;
% Zab=Zba=Zac=Zca=Zbc=Zcb=zm;

correctInput = false;
while not(correctInput)
    KZ = input('#  KZ = ');
    if not(isempty(KZ)) && isreal(KZ)
        correctInput = true;
    else
        fprintf(' KZ     ! \n');
    end
end

z  = 4+j*13;
zm = 2+j*4;
Zbase= [ z   zm   zm;
         zm  z    zm;
         zm  zm   z ];
     
fprintf('\n#  :\n');
Z = Zbase * KZ
     
%          - 120
Zs = S*Z*inv(S);

for k1=1:3,
    for k2=1:3,
        if abs(Zs(k1,k2))<1e-9,
            Zs(k1,k2)=0;
        end
    end
end

% 
fprintf('\n# :\n');
Zs
fprintf('\n(       )\n');
pause;
fprintf(['\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\b\b\b\b\b',...
    '\b\b\b\b\b\n\n']);

fprintf('\n\n### 1 / . 3 )\n');
%   .   
% Zaa=zz;  Zbb=Zcc=z;
% Zab=Zba=Zac=Zca=zmm;   Zbc=Zcb=zm;

z=4+j*13;     zm=2+j*4;
zz=1+j*0.5;  zmm=0.8+j*2;

Zbase = [ zz  zmm  zmm;
          zmm z    zm;
          zmm zm   z ];

fprintf('\n#  :\n');
Z = Zbase * KZ

%          - 120
Zs = S*Z*inv(S);

for k1=1:3,
    for k2=1:3,
        if abs(Zs(k1,k2))<1e-9,
            Zs(k1,k2)=0;
        end
    end
end

% 
fprintf('\n# :\n');
Zs

%% 
fprintf('\n#   %s\n',mfilename );


